## spring 88.0+dfsg1

=== CMakeLists.txt ===
 
project(Spring)

# CMake 2.4:
# - lacks some cross-compiling features and fails on windows
# CMake 2.6:
# - fixes: Windows command line is limited to 32k length commands
# CMake 2.6.3:
# + support for SOURCES attribute of add_custom_target() (not required anymore)
# CMake 2.8
# + works around command line length limited by using an @objectFilesList.txt parameter when linking
if    (WIN32)
	set(MIN_CMAKE_VERSION 2.8)
else  (WIN32)
	set(MIN_CMAKE_VERSION 2.6)
endif (WIN32)
cmake_minimum_required(VERSION ${MIN_CMAKE_VERSION})

SET(CMAKE_MODULES_SPRING "${CMAKE_CURRENT_SOURCE_DIR}/rts/build/cmake")
LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_MODULES_SPRING}")

# includes rts/build/cmake/Util.cmake
INCLUDE(Util)

CheckMinCMakeVersion(CUSTOM_TARGET_SOURCES_SUPPORT 2 6 3)

If    ("${CMAKE_BUILD_TYPE}" MATCHES "^DEBUG")
	Set(DEBUG_BUILD TRUE)
Else  ("${CMAKE_BUILD_TYPE}" MATCHES "^DEBUG")
	Set(DEBUG_BUILD FALSE)
EndIf ("${CMAKE_BUILD_TYPE}" MATCHES "^DEBUG")

# Tell windows to pass arguments around in @response files
# (32k arg limit workaround)
if    (WIN32)
	SET(CMAKE_C_USE_RESPONSE_FILE_FOR_OBJECTS 1)
	SET(CMAKE_CXX_USE_RESPONSE_FILE_FOR_OBJECTS 1)
endif (WIN32)

if    (APPLE)
	set(MACOSX_BUNDLE TRUE CACHE BOOL "Compile spring to work as a Bundle.app")
	if    (MACOSX_BUNDLE)
		add_definitions(-DMACOSX_BUNDLE)
	endif (MACOSX_BUNDLE)
else  (APPLE)
	set(MACOSX_BUNDLE FALSE)
endif (APPLE)

### Install path (relative to CMAKE_INSTALL_PREFIX)
if    (UNIX AND NOT MINGW)
	set (BINDIR  "bin"                CACHE STRING "Where to install binaries")
	set (LIBDIR  "lib"                CACHE STRING "Where to install libraries")
	set (MANDIR  "share/man"          CACHE STRING "Where to install man pages")
	set (DOCDIR  "share/doc/spring-VERSION" CACHE STRING "Where to install basic project documentation (README, LICENSE, etc.)") # TODO set correct version here, and re-enable userdocs in doc/CMakeLists.txt
	set (DATADIR "share/games/spring" CACHE STRING "Where to install game content")

	set (APPLICATIONS_DIR "share/applications" CACHE STRING "Where to install desktop files")
	set (PIXMAPS_DIR      "share/pixmaps"      CACHE STRING "Where to install icons")
	set (MIME_DIR         "share/mime"         CACHE STRING "Where MIME definitions are located")
	set (STABS_DEBUG_SYMBOLS FALSE CACHE BOOL "Use stabs debug symbols (-stabs) instead of the GDB format (-gdb). This probably makes gdb and eg. addr2line work better with windows binaries (depends mainly on the tools version).")
else  (UNIX AND NOT MINGW)
	set (BINDIR  "." CACHE STRING "Where to install binaries")
	set (LIBDIR  "." CACHE STRING "Where to install libraries")
	set (DOCDIR  "doc" CACHE STRING "Where to install basic project documentation (README, LICENSE, etc.)")
	set (DATADIR "." CACHE STRING "Where to install game content")

	if    (NOT MINGWLIBS)
		set(MINGWLIBS ${CMAKE_SOURCE_DIR}/mingwlibs CACHE PATH "Location of the mingwlibs package")
	endif (NOT MINGWLIBS)
	if    (NOT EXISTS "${MINGWLIBS}" OR NOT IS_DIRECTORY "${MINGWLIBS}")
		MESSAGE(FATAL_ERROR "MINGWLIBS is not a valid directory")
	endif (NOT EXISTS "${MINGWLIBS}" OR NOT IS_DIRECTORY "${MINGWLIBS}")
	include_directories(${MINGWLIBS}/include)
	set(CMAKE_LIBRARY_PATH ${MINGWLIBS}/dll)
	set(CMAKE_PREFIX_PATH ${MINGWLIBS})

	add_definitions(-D_WIN32_WINNT=0x500) ## win2k is minimum
	# some cross-compile fixes
	set (CMAKE_FIND_ROOT_PATH ${MINGWLIBS} ${CMAKE_FIND_ROOT_PATH})
	set (CMAKE_FIND_ROOT_PATH_MODE_LIBRARY ONLY)
	set (CMAKE_FIND_ROOT_PATH_MODE_INCLUDE ONLY)
	set (STABS_DEBUG_SYMBOLS FALSE CACHE BOOL "Use stabs debug symbols (-stabs) instead of the GDB format (-gdb). This probably makes gdb and eg. addr2line work better with windows binaries (depends mainly on the tools version).")
endif (UNIX AND NOT MINGW)

# In theory, it should be possible to set this to LIBDIR instead
# (next two are relative to CMAKE_INSTALL_PREFIX)
set (AI_LIBS_DIR "${DATADIR}"     CACHE STRING "Where to install Skirmish AI libraries")
set (AI_DATA_DIR "${AI_LIBS_DIR}" CACHE STRING "Where to install Skirmish AI additional files (eg. configuration)")
set (AI_TYPES    "ALL"            CACHE STRING "Which AI Interfaces (and Skirmish AIs using them) to build [ALL|NATIVE|JAVA|NONE]")

set(HEADLESS_SYSTEM FALSE CACHE BOOL "Compile for a headless system (default- and MT-spring will not be built!)")
SET(NO_SOUND FALSE CACHE BOOL "No sound output support")
if    (HEADLESS_SYSTEM AND NOT NO_SOUND)
	message(FATAL_ERROR "HEADLESS_SYSTEM requires NO_SOUND to be set!")
endif (HEADLESS_SYSTEM AND NOT NO_SOUND)

set(LOG_LEVEL "DEFAULT" CACHE STRING
		"The minimum log level.
		Log messages below this level
		will not be compiled into the binary.
		Available levels:
		* DEFAULT (DEBUG on debug builds, INFO on release builds)
		* DEBUG (log everything)
		* INFO
		* WARNING (only use this if you know what you are doing!)")
if    (NOT "${LOG_LEVEL}" STREQUAL "DEFAULT")
	add_definitions(-D_LOG_LEVEL_MIN=LOG_LEVEL_${LOG_LEVEL})
endif (NOT "${LOG_LEVEL}" STREQUAL "DEFAULT")

set(SYNCCHECK TRUE CACHE BOOL "Check sync during gameplay (Required for online play!)")
if    (SYNCCHECK)
	add_definitions(-DSYNCCHECK)
endif (SYNCCHECK)

if    (WIN32)
	set(NO_AVI FALSE CACHE BOOL "Disable in-game video recording")
	if    (NOT NO_AVI)
		add_definitions(-DAVI_CAPTURING)
	endif (NOT NO_AVI)
	set(WINDOWS_CONSOLE FALSE CACHE BOOL "Show a visible cmd.exe with stdout when spring runs")
	if    (NOT WINDOWS_CONSOLE)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mwindows")
	endif (NOT WINDOWS_CONSOLE)
endif (WIN32)

set(OPENMP TRUE CACHE BOOL "Enable local multithreading")
if    (OPENMP)
	include(FindOpenMP)
	if(OPENMP_FOUND)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
		# Currently FindOpenMP fails and doesn't give _any_ linker flags
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fopenmp -lgomp")
		set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fopenmp -lgomp")
		set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fopenmp -lgomp")
	endif(OPENMP_FOUND)
endif (OPENMP)

set(BUILTIN_DATADIRS "")
if    (NOT MINGW AND NOT MACOSX_BUNDLE)
	set (SPRING_DATADIR CACHE STRING "Path to game content (in addition to /etc/spring/datadir)")
	set (SPRING_DATADIR_INTERNAL "")
	if    (SPRING_DATADIR)
		set (SPRING_DATADIR_INTERNAL "${SPRING_DATADIR}${PATH_DELIM_T}")
	endif (SPRING_DATADIR)
	if    (CMAKE_INSTALL_PREFIX)
		set (SPRING_DATADIR_INTERNAL "${SPRING_DATADIR_INTERNAL}${CMAKE_INSTALL_PREFIX}${PATH_SEP_T}${DATADIR}")
	endif (CMAKE_INSTALL_PREFIX)
	set(BUILTIN_DATADIRS "${SPRING_DATADIR_INTERNAL}")
endif (NOT MINGW AND NOT MACOSX_BUNDLE)
if    (NOT "${AI_LIBS_DIR}" STREQUAL "${DATADIR}")
	# If the AI library dir is not the same as the normal data dir,
	# add it to the internal list of data dirs
	set(BUILTIN_DATADIRS "${BUILTIN_DATADIRS}${PATH_DELIM_T}${CMAKE_INSTALL_PREFIX}${PATH_SEP_T}${AI_LIBS_DIR}")
endif (NOT "${AI_LIBS_DIR}" STREQUAL "${DATADIR}")
if    (NOT "${AI_DATA_DIR}" STREQUAL "${DATADIR}" AND NOT "${AI_DATA_DIR}" STREQUAL "${AI_LIBS_DIR}")
	# If the AI data dir is not the same as the normal data dir
	# nor the AI library dir, add it to the internal list of data dirs
	set(BUILTIN_DATADIRS "${BUILTIN_DATADIRS}${PATH_DELIM_T}${CMAKE_INSTALL_PREFIX}${PATH_SEP_T}${AI_DATA_DIR}")
endif (NOT "${AI_DATA_DIR}" STREQUAL "${DATADIR}" AND NOT "${AI_DATA_DIR}" STREQUAL "${AI_LIBS_DIR}")
add_definitions(-DSPRING_DATADIR="${BUILTIN_DATADIRS}")

set (CUSTOM_COMPILER_DEFINITIONS "" CACHE STRING "Custom flags can be defined here")
if    (CUSTOM_COMPILER_DEFINITIONS)
	add_definitions(${CUSTOM_COMPILER_DEFINITIONS})
endif (CUSTOM_COMPILER_DEFINITIONS)

if    (MINGW)
	set(SDL_INCLUDE_DIR "${MINGWLIBS}/include/SDL")
endif (MINGW)
if    (WIN32)
	FIND_PACKAGE(Windres)
endif (WIN32)

FIND_PACKAGE(Boost 1.35.0 COMPONENTS thread regex program_options system signals REQUIRED)
INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})

FIND_PACKAGE(DevIL REQUIRED)

### mingwlibs
if     (MINGW)
	set(CMAKE_SHARED_LIBRARY_PREFIX "")
	set(CMAKE_SHARED_MODULE_PREFIX "")
elseif (UNIX)
	# unix specifics
else   (UNIX)
	# mac
	FIND_LIBRARY(COREFOUNDATION_LIBRARY CoreFoundation)
	INCLUDE_DIRECTORIES("${COREFOUNDATION_LIBRARY}/Headers")
endif  (MINGW)

### Compiler flags and defines based on build type
INCLUDE(TestCXXFlags)
if    (CMAKE_SIZEOF_VOID_P EQUAL 8)
	message (STATUS "Building Spring for 64bit environment")
	set (MARCH_FLAG CACHE STRING "CPU optimization (use i686 for generic optimization)")
else  (CMAKE_SIZEOF_VOID_P EQUAL 8)
	message (STATUS "Building Spring for 32bit environment")
	set (MARCH_FLAG ${MARCH} CACHE STRING "CPU optimization (use i686 for generic optimization)")
endif (CMAKE_SIZEOF_VOID_P EQUAL 8)

if    ($ENV{CXX} MATCHES "icpc")
	# intel C/C++ compiler fix; it does not support these flags:
	# "-march -mfpmath -msse -ggdb"
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -axK") # SSE1
	set(CXX_FLAGS_DEBUG_ADDITIONAL "-g -debug full")
else  ($ENV{CXX} MATCHES "icpc")
	if    (MARCH_FLAG)
		set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=${MARCH_FLAG}")
	endif (MARCH_FLAG)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SSE_FLAGS}") # SSE1
	if    (MINGW)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mthreads")
	endif (MINGW)

	set(CXX_FLAGS_DEBUG_ADDITIONAL "")
endif ($ENV{CXX} MATCHES "icpc")

# Add Link-Time-Optimization flags, if supported (GCC >= 4.5) and enabled
Set(CMAKE_CXX_FLAGS           "${CMAKE_CXX_FLAGS}           ${LTO_FLAGS}")
Set(CMAKE_EXE_LINKER_FLAGS    "${CMAKE_EXE_LINKER_FLAGS}    ${LTO_FLAGS}")
Set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${LTO_FLAGS}")

set(SIGNAL_NANS ${DEBUG_BUILD} CACHE BOOL "Enable NaN-Signalling")
if (SIGNAL_NANS)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsignaling-nans")
endif(SIGNAL_NANS)

# set the default build type
if    (NOT CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE RELWITHDEBINFO CACHE STRING
		"Choose the type of build, options are: RELWITHDEBINFO DEBUG DEBUG2 DEBUG3 RELEASE PROFILE"
		FORCE)
endif (NOT CMAKE_BUILD_TYPE)

set(COMMON_WARNINGS "")
if    (NOT OPENMP)
	# disable warnings about unknown pragmas because of:
	# "#pragma omp parallel for *"
	set(COMMON_WARNINGS "${COMMON_WARNINGS} -Wno-unknown-pragmas")
endif (NOT OPENMP)
# This would produce the maximum on warnings
#set(DEBUG_WARNINGS "-Wall -Wconversion ${COMMON_WARNINGS}")
# This should produce a sane amount of warnings
set(DEBUG_WARNINGS "-Wall -Wno-sign-compare ${COMMON_WARNINGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsingle-precision-constant -frounding-math")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${IEEE_FP_FLAG} -pipe -fno-strict-aliasing ${VISIBILITY_HIDDEN} ${VISIBILITY_INLINES_HIDDEN}")
add_definitions(-DSTREFLOP_SSE) # would break AI compiling, but is undefined in ./AI/CMakeLists.txt
add_definitions(-DBOOST_NO_FENV_H) # streflop overrides fenv.h
if (UNIX)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
endif (UNIX)
set(CMAKE_CXX_FLAGS_DEBUG           "${CXX_FLAGS_DEBUG_ADDITIONAL} -O1     ${DEBUG_WARNINGS}  -DDEBUG -D_DEBUG -DNO_CATCH_EXCEPTIONS")
set(CMAKE_CXX_FLAGS_DEBUG2          "${CXX_FLAGS_DEBUG_ADDITIONAL} -O0     ${DEBUG_WARNINGS}  -DDEBUG -D_DEBUG -DNO_CATCH_EXCEPTIONS")
set(CMAKE_CXX_FLAGS_DEBUG3          "${CXX_FLAGS_DEBUG_ADDITIONAL} -O0     ${DEBUG_WARNINGS}  -DDEBUG -D_DEBUG -DNO_CATCH_EXCEPTIONS")
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO  "${CXX_FLAGS_DEBUG_ADDITIONAL} -O2     ${COMMON_WARNINGS} -DNDEBUG")
set(CMAKE_CXX_FLAGS_RELEASE         "                              -O2     ${COMMON_WARNINGS} -DNDEBUG")
set(CMAKE_CXX_FLAGS_PROFILE         "                              -O2 -pg ${DEBUG_WARNINGS}  -DNDEBUG")
set(CMAKE_MODULE_LINKER_FLAGS_PROFILE "-pg")
set(CMAKE_SHARED_LINKER_FLAGS_PROFILE "-pg")
if (STABS_DEBUG_SYMBOLS)
	set(CMAKE_CXX_FLAGS_DEBUG           "${CMAKE_CXX_FLAGS_DEBUG}  -gstabs")
	set(CMAKE_CXX_FLAGS_DEBUG2          "${CMAKE_CXX_FLAGS_DEBUG2} -gstabs")

=== cont/CMakeLists.txt ===

# required for man pages (optional) and base files (mandatory)
FIND_PACKAGE(SevenZip REQUIRED)

### Make base-files (aka sdz's)
file (TO_NATIVE_PATH "${CMAKE_BINARY_DIR}/base" BASE_BUILD_DIR)
if    (CMAKE_HOST_WIN32)
	# As TO_NATIVE_PATH fails on windows, we need to do it manually
	string(REPLACE "/" "\\" BASE_BUILD_DIR "${BASE_BUILD_DIR}")
	set(BASE_BUILD_COMMAND call make_gamedata_arch.bat)
else  (CMAKE_HOST_WIN32)
	set(BASE_BUILD_COMMAND sh ./make_gamedata_arch.sh)
endif (CMAKE_HOST_WIN32)
add_custom_target(gamedata ALL
	COMMAND ${BASE_BUILD_COMMAND}
		${BASE_BUILD_DIR}
		${SEVENZIP_BIN}
	WORKING_DIRECTORY
		"${CMAKE_CURRENT_SOURCE_DIR}/base"
	)

### Install base-files
install (DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/ DESTINATION ${DATADIR}
		PATTERN ".gitignore" EXCLUDE
		PATTERN "base" EXCLUDE
		PATTERN "freedesktop" EXCLUDE
		PATTERN "CMakeLists.txt" EXCLUDE
		PATTERN "CMakeCache" EXCLUDE
		PATTERN "CMakeFiles" EXCLUDE
		PATTERN "Makefile" EXCLUDE
		PATTERN "cmake_install.cmake" EXCLUDE
	)

### Install content
install (DIRECTORY ${CMAKE_BINARY_DIR}/base DESTINATION ${DATADIR})


### Install freedesktop-files, mime-types etc.
if    (UNIX)
	install (
		FILES
			${CMAKE_CURRENT_SOURCE_DIR}/freedesktop/applications/spring.desktop
		DESTINATION
			${APPLICATIONS_DIR}
		)
	install (
		FILES
			${CMAKE_CURRENT_SOURCE_DIR}/freedesktop/mime/spring.xml
		DESTINATION
			${MIME_DIR}/packages
		)
	install (
		FILES
			${CMAKE_CURRENT_SOURCE_DIR}/freedesktop/pixmaps/spring.png
			${CMAKE_CURRENT_SOURCE_DIR}/freedesktop/pixmaps/application-x-spring-demo.png
		DESTINATION
			${PIXMAPS_DIR}
		)
endif (UNIX)


### Install dependencies (windows, mingwlibs DLLs)
if    (MINGW)
	install (DIRECTORY ${MINGWLIBS}/dll/ DESTINATION ${BINDIR} PATTERN "*.dll")
endif (MINGW)

=== doc/CMakeLists.txt ===

### make and install the man pages
if    (UNIX)
	FIND_PACKAGE(SevenZip)
	set(AsciiDoc_FIND_QUIETLY TRUE)
	FIND_PACKAGE(AsciiDoc)
	set(CREATE_MAN_PAGES)
	if    (SEVENZIP_FOUND AND ASCIIDOC_FOUND AND XSLTPROC_FOUND AND DOCBOOK_FOUND)
		execute_process(
			COMMAND "${ASCIIDOC_BIN}"
			RESULT_VARIABLE ASCIIDOC_RESULT
			ERROR_QUIET
			OUTPUT_QUIET
			ERROR_STRIP_TRAILING_WHITESPACE)
		if    (ASCIIDOC_RESULT EQUAL 0)
			set(CREATE_MAN_PAGES TRUE)
		else  (ASCIIDOC_RESULT EQUAL 0)
			set(CREATE_MAN_PAGES FALSE)
			message(STATUS "MAN pages will not be generated/installed (utility asciidoc is broken)")
		endif (ASCIIDOC_RESULT EQUAL 0)
	else  (SEVENZIP_FOUND AND ASCIIDOC_FOUND AND XSLTPROC_FOUND AND DOCBOOK_FOUND)
		set(MISSING_UTILS "")
		if    (NOT SEVENZIP_FOUND)
			set(MISSING_UTILS "${MISSING_UTILS} 7z*")
		endif (NOT SEVENZIP_FOUND)
		if    (NOT ASCIIDOC_FOUND)
			set(MISSING_UTILS "${MISSING_UTILS} asciidoc")
		endif (NOT ASCIIDOC_FOUND)
		if    (NOT XSLTPROC_FOUND)
			set(MISSING_UTILS "${MISSING_UTILS} xsltproc")
		endif (NOT XSLTPROC_FOUND)
		if    (NOT DOCBOOK_FOUND)
			set(MISSING_UTILS "${MISSING_UTILS} docbook-xsl")
		endif (NOT DOCBOOK_FOUND)
		message(STATUS "MAN pages will not be generated/installed; missing utilit(y|ies):${MISSING_UTILS}")
	endif (SEVENZIP_FOUND AND ASCIIDOC_FOUND AND XSLTPROC_FOUND AND DOCBOOK_FOUND)

	if    (CREATE_MAN_PAGES)
		set(MAN_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/manpages")
		set(MAN_BUILD_DIR  "${CMAKE_BINARY_DIR}/manpages")
		set(MAN_DEST_DIR   "${MANDIR}/man6")

		Set(man_src
				"${MAN_SOURCE_DIR}/spring.6.txt")
		Set(man_dst
				"${MAN_BUILD_DIR}/spring-dedicated.6.gz"
				"${MAN_BUILD_DIR}/spring-headless.6.gz"
				"${MAN_BUILD_DIR}/spring-multithreaded.6.gz"
				"${MAN_BUILD_DIR}/spring.6.gz")
		set_source_files_properties(${man_dst} PROPERTIES GENERATED TRUE)

		Add_Custom_Command(
			OUTPUT ${man_dst}
			COMMAND "${MAN_SOURCE_DIR}/make_manpages.sh"
				"${MAN_BUILD_DIR}"
				"${ASCIIDOC_BIN}"
				"${XSLTPROC_BIN}"
				"${DOCBOOK_XSL}"
				"${SEVENZIP_BIN}"
			DEPENDS ${man_src}
			WORKING_DIRECTORY "${MAN_SOURCE_DIR}"
			COMMENT "manpages: Generating" VERBATIM
		)

		add_custom_target(manpages ALL DEPENDS ${man_dst})

		install(FILES ${man_dst} DESTINATION "${MAN_DEST_DIR}")

		message(STATUS "MAN pages will be installed to {INSTALL_PREFIX}/${MAN_DEST_DIR}")
	endif (CREATE_MAN_PAGES)
endif (UNIX)


### make and install the user-doc pages (README, LICENSE, ...)
If     (WIN32)
	# We do not need the plain text version of the docu under windows
	Set(USERDOCS_PLAIN FALSE CACHE BOOL "Install plain/text engine user-docs (README, LICENSE, etc.)")
	Set(USERDOCS_HTML  TRUE  CACHE BOOL "Install HTML engine user-docs (README.html, LICENSE.html, etc.)")
	Set(DOC_DEST_DIR "${DOCDIR}")
Else   (WIN32)
	# TODO re-enable PLAIN on UNIX, once the correct version is set in ../CMakeLists.txt and make it a CACHE var then, also
	Set(USERDOCS_PLAIN FALSE       BOOL "Install plain/text engine user-docs (README, LICENSE, etc.)")
	Set(USERDOCS_HTML  FALSE CACHE BOOL "Install HTML engine user-docs (README.html, LICENSE.html, etc.)")
	Set(DOC_DEST_DIR "${DOCDIR}/engine")
EndIf  (WIN32)

Set(userdoc_INSTALL_HTML FALSE)
If     (USERDOCS_HTML)
	set(Pandoc_FIND_QUIETLY TRUE)
	FIND_PACKAGE(Pandoc)
	If     (NOT PANDOC_FOUND)
		Set(Markdown_FIND_QUIETLY TRUE)
		Find_Package(Markdown)
	EndIf  (NOT PANDOC_FOUND)

	If     (PANDOC_FOUND OR MARKDOWN_FOUND)
		Set(userdoc_INSTALL_HTML TRUE)

		# Generates "${name}.html" from "${name}(.markdown)"
		Macro    (Userdoc_GenerateHtml name var_srcFile)
			Set(DST_FILE_${name} "${CMAKE_CURRENT_BINARY_DIR}/${name}.html")

			If     (PANDOC_FOUND)
				Pandoc_MdToHtml(  convert_command_${name}
						"${${var_srcFile}}" "${DST_FILE_${name}}"
						"Spring RTS Game Engine - ${name}")
			Else   ()
				Markdown_MdToHtml(convert_command_${name}
						"${${var_srcFile}}" "${DST_FILE_${name}}")
			EndIf  ()
			add_custom_command(
				OUTPUT "${DST_FILE_${name}}"
				COMMAND ${convert_command_${name}}
				DEPENDS "${${var_srcFile}}"
				COMMENT "Creating userdoc ${name}.html" VERBATIM
			)

			List(APPEND userdoc_html_generated "${DST_FILE_${name}}")

			set_source_files_properties("${DST_FILE_${name}}" PROPERTIES GENERATED TRUE)
		EndMacro (Userdoc_GenerateHtml)
	Else   (PANDOC_FOUND OR MARKDOWN_FOUND)
		Message(SEND_ERROR "user-docs generation (html/text) is not possible (disable with USERDOCS_HTML=FALSE); missing utility: pandoc or markdown")
	EndIf  (PANDOC_FOUND OR MARKDOWN_FOUND)

	Set(userdoc_html_generated "")
EndIf  (USERDOCS_HTML)

If     (USERDOCS_PLAIN OR userdoc_INSTALL_HTML)
	Set(userdoc_plain "")

	Macro    (Userdoc_Enlist name)
		Set(userdoc_file_plain_${name} "${CMAKE_SOURCE_DIR}/${name}.markdown")
		If     (NOT EXISTS "${userdoc_file_plain_${name}}")
			Set(userdoc_file_plain_${name} "${CMAKE_SOURCE_DIR}/${name}")
		EndIf  ()

		List(APPEND userdoc_plain "${userdoc_file_plain_${name}}")

		If     (userdoc_INSTALL_HTML)
			Userdoc_GenerateHtml("${name}" userdoc_file_plain_${name})
		EndIf  (userdoc_INSTALL_HTML)
	EndMacro (Userdoc_Enlist)

	Userdoc_Enlist("AUTHORS")
	Userdoc_Enlist("README")
	Userdoc_Enlist("COPYING")
	Userdoc_Enlist("FAQ")
	Userdoc_Enlist("LICENSE")
	Userdoc_Enlist("THANKS")
EndIf  (USERDOCS_PLAIN OR userdoc_INSTALL_HTML)

Set(userdoc_INSTALL_PLAIN ${USERDOCS_PLAIN})
If     (userdoc_INSTALL_PLAIN)
	Set(userdoc_plain
			"${userdoc_plain}"
			"${CMAKE_SOURCE_DIR}/gpl-2.0.txt"
			"${CMAKE_SOURCE_DIR}/gpl-3.0.txt")

	Install(FILES ${userdoc_plain} DESTINATION "${DOC_DEST_DIR}")

	Message(STATUS "user-docs (plain/text) will be installed to {INSTALL_PREFIX}/${DOC_DEST_DIR}")
EndIf  (userdoc_INSTALL_PLAIN)

If     (userdoc_INSTALL_HTML)
	add_custom_target(userdocs ALL DEPENDS ${userdoc_html_generated})
	Add_Dependencies(generateSources userdocs)

	Set(userdoc_html
			"${userdoc_html_generated}"
			"${CMAKE_SOURCE_DIR}/gpl-2.0.html"
			"${CMAKE_SOURCE_DIR}/gpl-3.0.html")

	Install(FILES ${userdoc_html} DESTINATION "${DOC_DEST_DIR}")

	Message(STATUS "user-docs (html/text) will be installed to {INSTALL_PREFIX}/${DOC_DEST_DIR}")
EndIf  (userdoc_INSTALL_HTML)

=== rts/CMakeLists.txt ===
# Place executables and shared libs under "build-dir/",
# instead of under "build-dir/rts/"
# This way, we have the build-dir structure more like the install-dir one,
# which makes testing spring in the builddir easier, eg. like this:
# cd build-dir
# SPRING_DATADIR=$(pwd) ./spring
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")

SET(ENGINE_SRC_ROOT_DIR "${CMAKE_SOURCE_DIR}/rts")


### Assemble defines
SET(USE_MMGR FALSE CACHE BOOL "Use memory manager?")
if (USE_MMGR)
	ADD_DEFINITIONS(-DUSE_MMGR)
endif (USE_MMGR)

SET(TRACE_SYNC FALSE CACHE BOOL "Enable sync tracker")
if (TRACE_SYNC)
	ADD_DEFINITIONS(-DTRACE_SYNC)
endif (TRACE_SYNC)

SET(SYNCDEBUG FALSE CACHE BOOL "Enable sync debugger (needs SYNCCHECK=true)")
if (SYNCDEBUG)
	ADD_DEFINITIONS(-DSYNCDEBUG)
	If     (NOT "${CMAKE_BUILD_TYPE}" STREQUAL "DEBUG2" AND NOT "${CMAKE_BUILD_TYPE}" STREQUAL "DEBUG3")
		Message(FATAL_ERROR "You need CMAKE_BUILD_TYPE set to either DEBUG2 or DEBUG3 for a SYNCDEBUG build")
	EndIf  ()
	If     (NOT SYNCCHECK)
		Message(FATAL_ERROR "You need SYNCCHECK=TRUE for a SYNCDEBUG build")
	EndIf  ()
	If     (NOT TRACE_SYNC)
		Message(WARNING "It is recommended to use TRACE_SYNC=TRUE for a SYNCDEBUG build")
	EndIf  ()
endif (SYNCDEBUG)

# Only used by GML build, but used in builds/GML and lib/gml
SET(USE_GML_DEBUG FALSE CACHE BOOL "Use GML call debugging?")



### Assemble common incude dirs
INCLUDE_DIRECTORIES(BEFORE lib/lua/include)
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/include/AL)
INCLUDE_DIRECTORIES(${SPRING_MINIZIP_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

### Assemble common libraries
Add_Subdirectory(System/Sound)
if    (NO_SOUND)
	ADD_DEFINITIONS(-DNO_SOUND)
endif (NO_SOUND)

LIST(APPEND engineCommonLibraries ${DEVIL_IL_LIBRARY})

### Find include directories and add platform specific libraries
LIST(APPEND engineCommonLibraries ${Boost_REGEX_LIBRARY} ${Boost_THREAD_LIBRARY} ${Boost_PROGRAM_OPTIONS_LIBRARY} ${Boost_SYSTEM_LIBRARY} ${Boost_SIGNALS_LIBRARY})

LIST(APPEND engineCommonLibraries lua 7zip oscpack ${SPRING_MINIZIP_LIBRARY} streflop lobby assimp)

IF    (UNIX)
	# Needed for dynamically loading shared libraries (on some OS)
	LIST(APPEND engineCommonLibraries dl)
ENDIF (UNIX)

IF (MINGW)
	LIST(APPEND engineCommonLibraries ${WIN32_LIBRARIES} mingw32)
ENDIF (MINGW)


### Assemble engine sources
Add_Subdirectory(Game)
Add_Subdirectory(Lua)
Add_Subdirectory(ExternalAI)
Add_Subdirectory(Rendering)
Add_Subdirectory(aGui)
Add_Subdirectory(Menu)
Add_Subdirectory(Map)
Add_Subdirectory(Sim)
#Add_Subdirectory(System) # this is already added in ../

SET(engineSources
		${sources_engine_Game}
		${sources_engine_Lua}
		${sources_engine_Map}
		${sources_engine_Rendering}
		${sources_engine_aGui}
		${sources_engine_Menu}
		${sources_engine_Sim}
		${sources_engine_System}
		${sources_engine_ExternalAI}
		${nedmalloc_obj} # TODO remove? (seems never to be set)
	)

### Add headers for generated project files (e.g. Code::Blocks)
file(GLOB_RECURSE engineHeaders "*.h" "*.hpp")


### Add icon and manifest to exe using windres
IF    (WIN32)
	SET(ENGINE_ICON_DIR "${ENGINE_SRC_ROOT_DIR}")
	SET(ENGINE_ICON_RES "${ENGINE_SRC_ROOT_DIR}/icon.rc")
	SET(ENGINE_ICON_OBJ "${CMAKE_CURRENT_BINARY_DIR}/icon.o")
	CreateResourceCompileCommand(ENGINE_ICON "${ENGINE_ICON_DIR}" "${ENGINE_ICON_RES}" "${ENGINE_ICON_OBJ}")
ELSE  (WIN32)
	SET(ENGINE_ICON "")
ENDIF (WIN32)


Add_Subdirectory(builds)

=== test/CMakeLists.txt ===
# See README.md for usage instructions

FIND_PACKAGE(Boost 1.35.0 COMPONENTS unit_test_framework)
If    (NOT Boost_FOUND)
	Message(STATUS "Note: Unit tests will not be built: Boost::test library was not found")
Else  (NOT Boost_FOUND)
	# defines spring_test_compile_fail macro
	INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/tools/CompileFailTest/CompileFailTest.cmake)

	INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})

	FIND_PACKAGE(SDL REQUIRED)
	INCLUDE_DIRECTORIES(${SDL_INCLUDE_DIR})

	SET(ENGINE_SOURCE_DIR "${CMAKE_SOURCE_DIR}/rts")
	INCLUDE_DIRECTORIES(${ENGINE_SOURCE_DIR})
	If	(NOT WIN32)
		#Win32 tests links static
		add_definitions(-DBOOST_TEST_DYN_LINK)
	EndIf	(NOT WIN32)
	add_definitions(-DSYNCCHECK -DUNIT_TEST)

	Set(test_Log_sources
			"${ENGINE_SOURCE_DIR}/System/SafeCStrings.c"
			"${ENGINE_SOURCE_DIR}/System/Log/Backend.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/LogUtil.c"
			"${ENGINE_SOURCE_DIR}/System/Log/DefaultFilter.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/DefaultFormatter.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/FramePrefixer.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/ConsoleSink.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/StreamSink.cpp"
		)

	Add_Custom_Target(tests)



################################################################################
### UDPListener

	Set(test_UDPListener_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/Net/TestUDPListener.cpp"
			"${ENGINE_SOURCE_DIR}/System/Net/UDPListener.cpp"
			"${ENGINE_SOURCE_DIR}/System/Net/RawPacket.cpp"
			"${ENGINE_SOURCE_DIR}/System/Net/PackPacket.cpp"
			"${ENGINE_SOURCE_DIR}/System/Net/ProtocolDef.cpp"
			"${ENGINE_SOURCE_DIR}/System/Net/UDPConnection.cpp"
			"${ENGINE_SOURCE_DIR}/System/Net/Connection.cpp"
			"${ENGINE_SOURCE_DIR}/System/Net/Socket.cpp"
			"${ENGINE_SOURCE_DIR}/System/CRC.cpp"
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/NullGlobalConfig.cpp"
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/Nullerrorhandler.cpp"
			${test_Log_sources}
		)

	ADD_EXECUTABLE(test_UDPListener ${test_UDPListener_src})
	TARGET_LINK_LIBRARIES(test_UDPListener
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
			${Boost_SYSTEM_LIBRARY}
			${SDL_LIBRARY}
			${WS2_32_LIBRARY}
			7zip
		)

	ADD_TEST(NAME testUDPListener COMMAND test_UDPListener)
	Add_Dependencies(tests test_UDPListener)



################################################################################
### ILog

	Set(test_ILog_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/Log/TestILog.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/FileSink.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/OutputDebugStringSink.cpp"
			${test_Log_sources}
		)

	ADD_EXECUTABLE(test_ILog ${test_ILog_src})
	TARGET_LINK_LIBRARIES(test_ILog
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
		)

	ADD_TEST(NAME testILog COMMAND test_ILog)
	Add_Dependencies(tests test_ILog)



################################################################################
### SyncedPrimitive

	Set(test_SyncedPrimitive_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/Sync/TestSyncedPrimitive.cpp"
			"${ENGINE_SOURCE_DIR}/System/Sync/SyncChecker.cpp"
		)

	ADD_EXECUTABLE(test_SyncedPrimitive ${test_SyncedPrimitive_src})
	TARGET_LINK_LIBRARIES(test_SyncedPrimitive
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
		)

	ADD_TEST(NAME testSyncedPrimitive COMMAND test_SyncedPrimitive)
	Add_Dependencies(tests test_SyncedPrimitive)


################################################################################
### RectangleOptimizer

	Set(test_RectangleOptimizer_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/Misc/RectangleOptimizer.cpp"
			"${ENGINE_SOURCE_DIR}/System/Misc/RectangleOptimizer.cpp"
			${test_Log_sources}
		)

	ADD_EXECUTABLE(test_RectangleOptimizer ${test_RectangleOptimizer_src})
	TARGET_LINK_LIBRARIES(test_RectangleOptimizer
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
		)

	ADD_TEST(NAME testRectangleOptimizer COMMAND test_RectangleOptimizer)
	Add_Dependencies(tests test_RectangleOptimizer)


################################################################################
### BitwiseEnum

	Set(test_BitwiseEnum_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/Misc/TestBitwiseEnum.cpp"
		)

	ADD_EXECUTABLE(test_BitwiseEnum ${test_BitwiseEnum_src})
	TARGET_LINK_LIBRARIES(test_BitwiseEnum
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
		)

	# positive tests (should compile fine)
	ADD_TEST(NAME testBitwiseEnum COMMAND test_BitwiseEnum)
	Add_Dependencies(tests test_BitwiseEnum)

	# negative tests (must not compile)
	spring_test_compile_fail(testBitwiseEnum_fail1 ${test_BitwiseEnum_src} "-DTEST1")
	spring_test_compile_fail(testBitwiseEnum_fail2 ${test_BitwiseEnum_src} "-DTEST2")
	spring_test_compile_fail(testBitwiseEnum_fail3 ${test_BitwiseEnum_src} "-DTEST3")


################################################################################
### FileSystem

	Set(test_FileSystem_src
			"${ENGINE_SOURCE_DIR}/System/FileSystem/FileSystem.cpp"
			"${ENGINE_SOURCE_DIR}/System/FileSystem/FileSystemAbstraction.cpp"
			"${ENGINE_SOURCE_DIR}/System/Util.cpp"
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/FileSystem/TestFileSystem.cpp"
			${test_Log_sources}
		)

	ADD_EXECUTABLE(test_FileSystem ${test_FileSystem_src})
	TARGET_LINK_LIBRARIES(test_FileSystem
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
			${Boost_REGEX_LIBRARY}
		)

	ADD_TEST(NAME testFileSystem COMMAND test_FileSystem)
	Add_Dependencies(tests test_FileSystem)



################################################################################


EndIf (NOT Boost_FOUND)

=== tools/CMakeLists.txt ===

Add_Subdirectory(unitsync)
Add_Subdirectory(DemoTool)

# This is not part of the official source package
if    (IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/dirchange)
	Add_Subdirectory(dirchange)
endif (IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/dirchange)

=== AI/Interfaces/CMakeLists.txt ===
### AI Interfaces
#
# Functions and macros defined in this file:
# * AIInterfaceMessage
#

add_definitions(-DBUILDING_AI_INTERFACE)

set(AI_INTERFACES_SRC        "${CMAKE_CURRENT_SOURCE_DIR}")
set(AI_INTERFACES_LIBS       "${AI_LIBS_DIR}/AI/Interfaces")
set(AI_INTERFACES_DATA       "${AI_DATA_DIR}/AI/Interfaces")
set(AIINTERFACE_FIND_QUIETLY ${AI_FIND_QUIETLY})


# Print a message, but only if we are allowed to speak.
macro    (AIInterfaceMessage type msg)
	if    (NOT AIINTERFACE_FIND_QUIETLY)
		message(${type} "${msg}")
	endif (NOT AIINTERFACE_FIND_QUIETLY)
endmacro (AIInterfaceMessage type msg)


# Add all AI Interface submodules
GetListOfSubModules(AI_INTERFACE_DIRS)
set(DEPS_AI_INTERFACES )
foreach    (aiInterfaceDir ${AI_INTERFACE_DIRS})
	if     (NOT "${aiInterfaceDir}" STREQUAL "Python")
	Add_Subdirectory(${aiInterfaceDir})
	list(APPEND DEPS_AI_INTERFACES ${aiInterfaceDir}-AIInterface)
	elseif (NOT "${aiInterfaceDir}" STREQUAL "Python")
		AIInterfaceMessage(STATUS "Python AI Interface is not yet compatible with pureint changes -> temporarily disabled")
	endif  (NOT "${aiInterfaceDir}" STREQUAL "Python")
endforeach (aiInterfaceDir)
MakeGlobal(DEPS_AI_INTERFACES)

=== AI/Skirmish/CMakeLists.txt ===
### Skirmish AIs
#
# Functions and macros defined in this file:
# * SkirmishAIMessage
#

add_definitions(-DBUILDING_SKIRMISH_AI)

set(SKIRMISH_SRC            "${CMAKE_CURRENT_SOURCE_DIR}")

# Print a message, but only if we are allowed to speak.
macro    (SkirmishAIMessage type msg)
	if    (NOT SKIRMISHAI_FIND_QUIETLY)
		message(STATUS "${msg}")
	endif (NOT SKIRMISHAI_FIND_QUIETLY)
endmacro (SkirmishAIMessage typemsg)


# Add all Skirmish AI submodules
GetListOfSubModules(SKIRMISH_AI_DIRS)
set(DEPS_AI_SKIRMISH )
foreach    (skirmishAIDir ${SKIRMISH_AI_DIRS})
	Add_Subdirectory(${skirmishAIDir})
	list(APPEND DEPS_AI_SKIRMISH ${skirmishAIDir})
endforeach (skirmishAIDir)
MakeGlobal(DEPS_AI_SKIRMISH)

=== AI/Wrappers/CMakeLists.txt ===
### AI Wrappers
#
# Functions and macros defined in this file:
# * AIWrapperMessage
#

#add_definitions(-DBUILDING_AI_WRAPPER)

set(AI_WRAPPER_SRC         "${CMAKE_CURRENT_SOURCE_DIR}")
set(AIWRAPPER_FIND_QUIETLY ${AI_FIND_QUIETLY})


# Print a message, but only if we are allowed to speak.
macro    (AIWrapperMessage type msg)
	if    (NOT AIWRAPPER_FIND_QUIETLY)
		message(${type} "${msg}")
	endif (NOT AIWRAPPER_FIND_QUIETLY)
endmacro (AIWrapperMessage type msg)


# Configure all AI Wrapper submodules that need processing
GetListOfSubModules(AI_WRAPPER_DIRS)
set(DEPS_AI_WRAPPERS )
foreach    (aiWrapperDir ${AI_WRAPPER_DIRS})
	# exclude CUtils here, as it was already included before
	if    (NOT "${aiWrapperDir}" STREQUAL "CUtils")
		Add_Subdirectory(${aiWrapperDir})
	endif (NOT "${aiWrapperDir}" STREQUAL "CUtils")
	list(APPEND DEPS_AI_WRAPPERS ${aiWrapperDir}-AIWrapper)
endforeach (aiWrapperDir)
MakeGlobal(DEPS_AI_WRAPPERS)

=== rts/Game/CMakeLists.txt ===

# This list was created using this *nix shell command:
# > find . -name "*.cpp" | sort
SET(sources_engine_Game_common
		"${CMAKE_CURRENT_SOURCE_DIR}/Action.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/AviVideoCapturing.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/CameraController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/FPSController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/FreeController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/OrbitController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/OverheadController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/OverviewController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/RotOverheadController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/SmoothController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/TWController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/CameraHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/ChatMessage.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/ClientSetup.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/CommandMessage.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Console.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/ConsoleHistory.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/DummyVideoCapturing.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/FPSUnitController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Game.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GameController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GameData.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GameHelper.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GameServer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GameSetup.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GameVersion.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GlobalUnsynced.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/IVideoCapturing.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/InMapDraw.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/InMapDrawModel.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LoadScreen.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Messages.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/NetCommands.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/OSCStatsSender.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Player.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/PlayerBase.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/PlayerHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/PlayerRoster.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/PlayerRosterDrawer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/PlayerStatistics.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/PreGame.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SelectedUnits.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SelectedUnitsAI.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SyncedGameCommands.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/TraceRay.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/CommandColors.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/CursorIcons.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/EndGameBox.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/GameInfo.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/GameSetupDrawer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/GuiHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/HwMouseCursor.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/InfoConsole.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/InputReceiver.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/KeyAutoBinder.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/KeyBindings.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/KeyCodes.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/KeySet.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/MiniMap.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/MouseCursor.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/MouseHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/ProfileDrawer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/QuitBox.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/ResourceBar.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/SelectionKeyHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/ShareBox.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/StartPosSelecter.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/TooltipConsole.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/UnitTracker.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UnsyncedGameCommands.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/WaitCommandsAI.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/WordCompletion.cpp"
	)
SET(sources_engine_Game_Server
		"${CMAKE_CURRENT_SOURCE_DIR}/Server/GameParticipant.cpp"
	)
SET(sources_engine_Game
		${sources_engine_Game_common}
		${sources_engine_Game_Server}
	)

MakeGlobal(sources_engine_Game_common)
MakeGlobal(sources_engine_Game_Server)
MakeGlobal(sources_engine_Game)

=== rts/Lua/CMakeLists.txt ===

# This list was created using this *nix shell command:
# > find . -name "*.cpp"" | sort
SET(sources_engine_Lua
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaBitOps.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaCallInCheck.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaConstCMD.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaConstCMDTYPE.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaConstCOB.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaConstGL.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaConstGame.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaFBOs.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaFeatureDefs.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaFonts.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaGaia.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaHandle.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaHandleSynced.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaIO.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaInputReceiver.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaLobby.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaMaterial.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaMetalMap.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaOpenGL.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaOpenGLUtils.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaParser.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaPathFinder.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaRBOs.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaRules.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaRulesParams.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaScream.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaShaders.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaSyncedCall.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaSyncedCtrl.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaSyncedMoveCtrl.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaSyncedRead.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaSyncedTable.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaTextures.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaUI.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaUnitDefs.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaUnitRendering.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaUnsyncedCall.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaUnsyncedCtrl.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaUnsyncedRead.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaUtils.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaVFS.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaWeaponDefs.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaZip.cpp"
	)

MakeGlobal(sources_engine_Lua)

=== rts/Map/CMakeLists.txt ===

# This list was created using this *nix shell command:
# > find . -name "*.cpp"" | sort
SET(sources_engine_Map
		"${CMAKE_CURRENT_SOURCE_DIR}/BaseGroundDrawer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/BasicMapDamage.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Ground.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/HeightLinePalette.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/HeightMapTexture.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MapDamage.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MapInfo.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MapParser.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MetalMap.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/NoMapDamage.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/ReadMap.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/Frustum.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/Plane.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/SM3GroundDrawer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/SM3Map.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/terrain/Lightcalc.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/terrain/QuadRenderData.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/terrain/Terrain.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/terrain/TerrainTexEnvCombine.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/terrain/TerrainTexture.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/terrain/TerrainTextureGLSL.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/terrain/TerrainUtil.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/terrain/TerrainVertexBuffer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/terrain/Textures.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SMF/SMFGroundDrawer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SMF/SMFGroundTextures.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SMF/SMFMapFile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SMF/SMFReadMap.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SMF/SMFRenderState.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SMF/Legacy/LegacyMeshDrawer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SMF/ROAM/Patch.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SMF/ROAM/RoamMeshDrawer.cpp"
	)

MakeGlobal(sources_engine_Map)

=== debian/changelog ===
spring (88.0+dfsg1-1.1ubuntu1) quantal; urgency=low

  * Fix glShaderSource stub signature to match that in <GL/glext.h>.

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 09 Sep 2012 23:58:23 +0100

spring (88.0+dfsg1-1.1build1) quantal; urgency=low

  * Rebuild for libglew1.8.

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 09 Sep 2012 22:45:12 +0100

spring (88.0+dfsg1-1.1) unstable; urgency=low

  * Non maintainer upload
  * Work around build failure with GCC 4.7, build with -fpermissive.
    Closes: #667379.

 -- Matthias Klose <doko@debian.org>  Thu, 10 May 2012 20:41:35 +0200

spring (88.0+dfsg1-1) unstable; urgency=low

  [ Jan Dittberner ]
  * New upstream version.
  * remove include/GL and include/SDL when repacking upstream tarball
  * debian/rules: remove unneeded repacking from get-orig-source target.
    Repacking is done in debian/new-upstream that is called by uscan
  * refresh debian/patches/0005-fix-sdl-build.patch
  * update Standards-Version to 3.9.3 (no changes)
  * update debian/copyright to 1.0 format

  [ Marco Amadori ]
  * Refreshed boost fix patch.
  * Include python unitsync bindings.

 -- Jan Dittberner <jandd@debian.org>  Sat, 31 Mar 2012 13:07:36 +0200

spring (85.0+dfsg1-3) unstable; urgency=low

  * Fixes compilation problems under boost 1.48 (Closes: #660450).
  * Parallel build the debhelper's way.
  * Removed plus signs in debian/rules.

 -- Marco Amadori <marco.amadori@gmail.com>  Mon, 27 Feb 2012 23:05:00 +0100

=== debian/control ===
Source: spring
Section: games
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Marco Amadori <marco.amadori@gmail.com>, Jan Dittberner <jandd@debian.org>
Build-Depends: debhelper (>= 7.0.50~),
 cmake,
 asciidoc,
 docbook-xml,
 docbook-xsl,
 xsltproc,
 bzip2,
 default-jdk,
 libboost-dev,
 libboost-program-options-dev,
 libboost-regex-dev,
 libboost-serialization-dev,
 libboost-signals-dev,
 libboost-system-dev,
 libboost-thread-dev,
 libdevil-dev,
 libfreetype6-dev,
 libglew-dev,
 libogg-dev,
 libopenal-dev,
 libsdl1.2-dev,
 libvorbis-dev,
 libxcursor-dev,
 p7zip-full,
 python-pygccxml,
 zip,
 libvecmath-java,
 libjna-java
Standards-Version: 3.9.3
Vcs-Git: git://git.debian.org/pkg-games/spring.git
Vcs-Browser: http://git.debian.org/?p=pkg-games/spring.git;a=summary
Homepage: http://springrts.com

Package: spring
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends},
 spring-common (= ${source:Version}), otf-freefont
Conflicts: spring-engine
Recommends: springlobby | spring-lobby
Suggests: spring-maps-deltasiege | spring-map,
 spring-mods-kernelpanic | spring-mod, spring-javaai, libtxc-dxtn0
Description: modern full-3D RTS game engine
 Spring is a modern full-3D RTS (Real Time Strategy) game engine originally
 created to bring the gameplay experience of Total Annihilation into 3D.
 Games are played using one of a number of mods.
 .
 This package just includes the game engine and the default AI, with no maps,
 mods or rich user interface.

Package: spring-common
Architecture: all
Depends: ${misc:Depends}
Conflicts: spring-engine
Recommends: spring (>= ${source:Version}),
 spring (<< ${source:Version}.1~), springlobby | spring-lobby
Suggests: spring-maps-deltasiege | spring-map,
 spring-mods-kernelpanic | spring-mod
Description: modern full-3D RTS game engine (common files)
 Spring is a modern full-3D RTS (Real Time Strategy) game engine originally
 created to bring the gameplay experience of Total Annihilation into 3D.
 Games are played using one of a number of mods.
 .
 This package just includes the game engine's arch independent files, with no
 maps, mods or rich user interface.

Package: spring-dbg
Section: debug
Architecture: i386 amd64
Priority: extra
Depends: ${misc:Depends}, spring (= ${binary:Version})
Description: modern full-3D RTS game engine (debugging symbols)
 Spring is a modern full-3D RTS (Real Time Strategy) game engine originally
 created to bring the gameplay experience of Total Annihilation into 3D.
 Games are played using one of a number of mods.
 .
 This package contains the debugging symbols for the spring binaries.

Package: spring-javaai
Architecture: all
Depends: ${misc:Depends}, default-jre, libjna-java, libvecmath-java,
 spring (>= ${source:Version})
Conflicts: spring-engine
Description: modern full-3D RTS game engine (Java AIs)
 Spring is a modern full-3D RTS (Real Time Strategy) game engine originally
 created to bring the gameplay experience of Total Annihilation into 3D.
 Games are played using one of a number of mods.
 .
 This package contains Java based AIs and the spring interface libraries these
 require.

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d+$// \
 http://sf.net/springrts/spring_([\d\.]+)_src\.tar\.gz debian debian/new-upstream
